// -*-C++-*-
//
// File:      AsciiFormatter.h
// Author:    Jorgo Bakker (jbakker@rssd.esa.int)
// Generated: Mon Jan 27 14:09:35 CET 2003
// Usage:     -
// Info:      -


#ifndef AsciiFormatter_h
#define AsciiFormatter_h

#include "MessageFormatter.h"

class AsciiFormatter : public /* implementation of */ MessageFormatter
{
public:
  AsciiFormatter();
  virtual ~AsciiFormatter();

  void setDecodeListener(MessageHandler*) {/*nothing!*/}

  virtual void message(const std::string& name,
		       const std::string& text);

  virtual void warning(const std::string& name,
		       const std::string& code, 
		       const std::string& text);

  virtual void error(const std::string& name,
		     const std::string& code, 
		     const std::string& text);

  virtual void fatal(const std::string& name,
		     const std::string& code, 
		     const std::string& text);

  virtual void decode() { /*nothing!*/}

private:
  AsciiFormatter(const AsciiFormatter&);             // disabled!
  AsciiFormatter& operator=(const AsciiFormatter&); // disabled!
};

#endif
