// -*-c++-*-
// (c) 1997 European Space Agency - written by Marco Beijersbergen
//

#ifndef Msg_h
#define Msg_h

#include <string>
#include <iostream>

typedef std::string Code;

struct Msg {
  class Layer
  {
  public:
    Layer() : _data(0) {}
    Layer(int i) : _data(i) {}
    operator int() {return _data;}
    friend std::ostream& operator<<(std::ostream&,const Layer&);
    friend std::istream& operator>>(std::istream&,Layer&);
  private:
    int _data;
  };
  static const  Layer UI, Meta, App, AppLib, Lib, Core, Kernel;

  class Verbosity
  {
  public:
    Verbosity() : _data(0) {}
    Verbosity(int i) : _data(i) {}
    operator int() const {return _data;}
    friend std::ostream& operator<<(std::ostream&,const Verbosity&);
    friend std::istream& operator>>(std::istream&,Verbosity&);
  private:
    int _data;
  };
  static const Verbosity  Silent, Sparse, Verbose, Noisy, Always;

  Layer layer;
  Verbosity level;

};

inline std::ostream& operator<<(std::ostream& os,const Msg::Layer& l)
{
  return (os << l._data);
}
inline std::istream& operator>>(std::istream& is,Msg::Layer& l)
{
  return (is >> l._data);
}
inline std::ostream& operator<<(std::ostream& os,const Msg::Verbosity& v)
{
  return (os << v._data);
}
inline std::istream& operator>>(std::istream& is,Msg::Verbosity& v)
{
  return (is >> v._data);
}
#endif
