/*
    error.cc

    Implementation of the C interface to the error library.
*/

#include "errstr.h"
#include "error.h"
#include <cstdio>
#include <cstdarg>

void sas_message(MsgLayer layer, MsgLevel level, const char* fmt, ...)
{
  char s[4096];

  va_list args;
  va_start(args,fmt);
  vsprintf(s,fmt,args);
  va_end(args);

  errstr << s << Sas::message(Msg::Layer(layer),Msg::Verbosity(level));
}

void sas_warning(const char* code, const char* fmt, ...)
{
  char s[4096];

  va_list args;
  va_start(args,fmt);
  vsprintf(s,fmt,args);
  va_end(args);

  errstr << s << Sas::warning(code);
}

void sas_error(const char* code, const char* fmt, ...)
{
  char s[4096];

  va_list args;
  va_start(args,fmt);
  vsprintf(s,fmt,args);
  va_end(args);

  errstr << s << Sas::error(code);
}

void sas_fatal(const char* code, const char* fmt, ...)
{
  char s[4096];

  va_list args;
  va_start(args,fmt);
  vsprintf(s,fmt,args);
  va_end(args);

  errstr << s << Sas::fatal(code);
}

