/*
    error.h

    C interface to the error handling.

    (c) 1999 European Space Agency - written by Marco Beijersbergen
*/

#ifndef error_h
#define error_h

#ifdef __cplusplus
extern "C" {
#endif

typedef enum { UIMsg=1, MetaMsg, AppMsg, AppLibMsg, LibMsg, CoreMsg, KernelMsg } MsgLayer;

typedef enum { SilentMsg, SparseMsg, VerboseMsg, NoisyMsg } MsgLevel;

void sas_message(MsgLayer layer, MsgLevel level, const char* fmt, ...);

void sas_warning(const char* code, const char* fmt, ...);

void sas_error(const char* code, const char* fmt, ...);

void sas_fatal(const char* code, const char* fmt, ...);

#ifdef __cplusplus
}
#endif

#endif
